import matplotlib.pyplot as plt
import matplotlib
import datetime as dt
import numpy as np
import matplotlib.cm as cm

csvFiles = []
listFiles = open('./RawFlowData/file_list.txt', 'r')
for line in listFiles:
    csvFiles.append( line[:-1] )   # The -1 part remove the line break
print (csvFiles)
listFiles.close()

# Sort the files by time

time0File = []
time1File = []

for filename in csvFiles:
    file = open('./RawFlowData/'+filename)
    for i in range(3):
        file.readline()
    firstLine = file.readline()
    print (filename, firstLine.split(',')[0])
    lineTime = dt.datetime.strptime(firstLine.split(',')[0], '%m/%d/%y %H:%M:%S')  #02/04/20 16:29:29
    time0File.append(lineTime)
    
    for line in file:
        pass
    lineTime = dt.datetime.strptime(line.split(',')[0], '%m/%d/%y %H:%M:%S')  #last line
    time1File.append(lineTime)
    
    file.close()
    
# Sort the files.  The original naming was not very disciplined
csvFiles = [x for _,x in sorted(zip(time0File,csvFiles))]
time1File = [x for _,x in sorted(zip(time0File,time1File))]
time0File.sort()


# Figure out the time spans during which each channel existed 
channelTimeSpans = {}#'channelName':[[t11,t12],[t21,t22]]}


count = -1
for filename in csvFiles:
    count += 1
    file = open('./RawFlowData/'+filename)
    line = file.readline()
    line = file.readline()
    file.close()
    channels = line[:-1].split(',')
    for channel in channels:
        if not channel in channelTimeSpans:
            channelTimeSpans [channel] = []
        channelTimeSpans [channel].append([time0File[count], time1File[count]])

print (sorted(channelTimeSpans.keys()))
#exit()
# Plotting
fig = plt.figure(figsize=(32, 18)  )
ax = fig.add_subplot(1, 1, 1)
myrow = 0
for channel in sorted(channelTimeSpans.keys()):
    myrow += 1
    print (channel, len(channelTimeSpans[channel]))
    for window in channelTimeSpans[channel]:
        ax.plot(window, [myrow,myrow], c=cm.plasma(myrow/len(channelTimeSpans.keys())*0.75), lw='2')
ax.set_yticks(range(1,myrow+1)) 
ax.set_yticklabels(sorted(channelTimeSpans.keys()))

bigWindow = [channelTimeSpans['Time'][0][0], channelTimeSpans['Time'][-1][-1]]

# Manually draw grid horizontal cells as visual guides
for i in range(myrow+1):
    ax.plot(bigWindow, [0.5+i, 0.5+i], c='gray', lw=0.5)
    
ax.set_xlim(bigWindow)
ax.set_ylim([0,myrow+1])
plt.title('Channel-time map for EGS Collab Exp. 1 long term injection')
plt.tight_layout()
plt.savefig('ChannelTimeMap_FullFiles.png', dpi=100)
plt.show()   
