import matplotlib.pyplot as plt
import matplotlib
import datetime as datetime
from datetime import timedelta
import numpy as np
import pickle
import bisect

def MapChannelInFile (filename, channel):
    file = open(filename, 'r')
    file.readline()
    myChannels = file.readline()[:-1].split(',')
    if channel in myChannels:
        return (myChannels.index(channel))
    else:
        return (-1)
    



csvFiles = []
listFiles = open('./RawFlowData/file_list.txt', 'r')

for line in listFiles:
    csvFiles.append( line[:-1] )   # The -1 part remove the line break
print (csvFiles)
listFiles.close()

# Sort the files by time

time0File = []
time1File = []

# The following two hard-coded if loops can need to be set to True in first run.  Each will generate a pickle file.  In subsequent runs, you can set both to False to save on file parsing time.

# Going through all files to collect basic information so that we know the time span each file covers.
if True:
    for filename in csvFiles:
        file = open('./RawFlowData/'+filename)
        for i in range(3):
            file.readline()
        firstLine = file.readline()
        print (filename, firstLine.split(',')[0])
        lineTime = datetime.datetime.strptime(firstLine.split(',')[0], '%m/%d/%y %H:%M:%S')  #02/04/20 16:29:29
        time0File.append(lineTime)
        
        nLine = 1
        for line in file:
            nLine += 1
        lineTime = datetime.datetime.strptime(line.split(',')[0], '%m/%d/%y %H:%M:%S')  #last line
        time1File.append(lineTime)
        
        file.close()
        
    #    print (time1File[-1], time0File[-1], nLine, (time1File[-1] - time0File[-1]).total_seconds())
        
    # Sort the files.  The original naming was not very disciplined
    csvFiles = [x for _,x in sorted(zip(time0File,csvFiles))]
    time1File = [x for _,x in sorted(zip(time0File,time1File))]
    time0File.sort()    
    
    
    pickleFile = open('FileInfo.pickle', "wb")
    pickle.dump([csvFiles, time0File, time1File], pickleFile)
    pickleFile.close()
else:
    pickleFile = open('FileInfo.pickle', "rb")
    csvFiles, time0File, time1File= pickle.load(pickleFile)
    
for i in range(len(csvFiles)):
    print (i, csvFiles[i], time1File[i], time1File[i])

if True: #Extract all meta data
    CSVNotes = {}
    
    out = open('AllMetaData.txt', 'w')
    for filename in csvFiles:
        file = open('./RawFlowData/'+filename, 'r')
        file.readline()
        line = file.readline()
        n = len(line.split(','))
        file.readline()
        for line in file:
            if len(line.split(',')[n-1]) > 1:
                t = line.split(',')[n-1]
                for i in range(n,len(line.split(','))): # If the meta data text included comma
                    t += ',' + line.split(',')[i]
                t = t[:-1]
                               
                out.write(line.split(',')[0] + ', ' + t + '\n')
                CSVNotes[line.split(',')[0]] = t
    pickleFile = open('CSVNotes.pickle', "wb")
    pickle.dump(CSVNotes, pickleFile)
    pickleFile.close()
    exit()
else:
    pickleFile = open('CSVNotes.pickle', "rb")
    CSVNotes= pickle.load(pickleFile)
    pickleFile.close()
    

    
chLim = {}
chLim['InjectionIntervalTemp'] = [0, 40]
chLim['PrdIntvTemp'] = [10, 40]
chLim['PrdBotTemp'] = [10, 40]
chLim['P_Bottom_Temp_Questionable'] = [10, 40]
chLim['P_Bottom_Temp_Upgraded'] = [10, 40]
chLim['P_Interval_Temp_Questionable'] = [10, 40]
chLim['P_Interval_Temp_Upgraded'] = [10, 40]

# Time windows to skip
# 2019 April 3 18:00 to April 4 22:00
# 2019 April 12 8:20 to April 17 15:20
# 2019 June 4 14:00 to June 5 14:00  #Some signal from testing the packers, not real testing.
# 2019 Aug 17 23:34:59 to Aug 17 21:16:31, all channels recorded constant values due to system error.
# 2019 Oct 12 17:29:22 to Oct 14 16:39:56, all channels recorded constant values due to system error.
# 2019  Oct. 29 21:00 to Oct. 30 20:00
# 2019 Nov 1 12:00 to Nov 7 22:00  Injection stopped on Nov. 1 due to some failure.  Some testing on Nov 5 but I am not including the data.
# 2020 Jan 14 00:45 to Jan 15 17:30  # Injection stopped to fix packer  Restarted on Jan 15, but had a short interruption due to isco pump b fault


chHistory = {}
chHistory['InjectionPressure'] = [['Channel:SNL 10', datetime.datetime(2019,1,1), datetime.datetime(2019,4,3,18,0,0)],
                                  ['Channel:', datetime.datetime(2019,4,4,21,0,0), datetime.datetime(2019,4,12,8,20,0)],
                                  ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                  ['Channel:', datetime.datetime(2019,6,  5,14, 0, 0), datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31), datetime.datetime(2019,10,12,17,29,22)],
                                  ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                  ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                  ['Channel:', datetime.datetime(2019,11,7,22,0,0), datetime.datetime(2020,1,14,0,45,0)],
                                  ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]
 
chHistory['InjectionRate'] = [['Channel:Triplex Net Flow', datetime.datetime(2019,1,1), datetime.datetime(2019,4,3,18,0,0)],
                                  ['Channel:', datetime.datetime(2019,4,4,21,0,0), datetime.datetime(2019,4,12,8,20,0)],
                                  ['Channel:Quizix Flow', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,4,18, 14, 1, 12)],
                                  ['Channel:Triplex Net Flow', datetime.datetime(2019,4,18,14,8,0), datetime.datetime(2019,5,30,15,8,55)],
                                  ['Channel:Quizix Flow', datetime.datetime(2019,5,30,15,22,5), datetime.datetime(2019,6,4,14,0,0)],
                                  ['Channel:', datetime.datetime(2019,6,5,14,0,0), datetime.datetime(2019,6,11, 14, 28,19)],
                                  ['Channel:Triplex Net Flow', datetime.datetime(2019,6,11, 14, 28,19), datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31), datetime.datetime(2019,10,12,17,29,22)],
                                  ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                  ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                  ['Channel:', datetime.datetime(2019,11,7,22,0,0), datetime.datetime(2020,1,14,0,45,0)],
                                  ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]
                               ]

chHistory['InjectionRate'] = [
                                  ['Channel:Triplex Net Flow', datetime.datetime(2019,1,1), datetime.datetime(2019,4,3,18,0,0)],
                                  ['Channel:', datetime.datetime(2019,4,4,21,0,0), datetime.datetime(2019,4,12,8,20,0)],
                                  ['Channel:Quizix Flow', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,4,18, 14, 1, 12)],
                                  ['Channel:Triplex Net Flow', datetime.datetime(2019,4,18,14,8,0), datetime.datetime(2019,5,30,15,8,55)],
                                  ['Channel:Quizix Flow', datetime.datetime(2019,5,30,15,22,5), datetime.datetime(2019,6,4,14,0,0)],
                                  ['Channel:', datetime.datetime(2019,6,5,14,0,0), datetime.datetime(2019,6,11, 14, 28,19)],
                                  ['Channel:Triplex Net Flow', datetime.datetime(2019,6,11, 14, 28,19), datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31), datetime.datetime(2019,10,12,17,29,22)],
                                  ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                  ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                  ['Channel:', datetime.datetime(2019,11,7,22,0,0), datetime.datetime(2020,1,14,0,45,0)],
                                  ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]
                               ]

chHistory['P_Interval_Flow'] =  [['Channel:PNNL 13', datetime.datetime(2019,4,4,20,51,0), datetime.datetime(2019,4,12,8,20,0)],
                                ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                ['Channel:', datetime.datetime(2019,6,5,14,0,0),  datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31),datetime.datetime(2019,10,12,17,29,22)],
                                ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                ['Channel:', datetime.datetime(2019,11,7,22,0,0),  datetime.datetime(2019,12,17,15,0,0)],
                                ['Channel:', datetime.datetime(2019,12,19,16,0,0), datetime.datetime(2020,1,13,14,15,0)],
                                ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]

chHistory['P_Bottom_Flow'] =  [['Channel:P Bot Flow', datetime.datetime(2019,4,4,20,51,0), datetime.datetime(2019,4,12,8,20,0)],
                                ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                ['Channel:', datetime.datetime(2019,6,5,14,0,0),  datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31),datetime.datetime(2019,10,12,17,29,22)],
                                ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                ['Channel:', datetime.datetime(2019,11,7,22,0,0),  datetime.datetime(2019,12,17,15,0,0)],
                                ['Channel:', datetime.datetime(2019,12,19,16,0,0), datetime.datetime(2020,1,13,14,15,0)],
                                ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]

chHistory['PDT_Flow'] =  [['Channel:PDT Collar Flow', datetime.datetime(2019,4,4,20,51,0), datetime.datetime(2019,4,12,8,20,0)],
                                ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                ['Channel:', datetime.datetime(2019,6,5,14,0,0), datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31), datetime.datetime(2019,10,12,17,29,22)],
                                ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                ['Channel:', datetime.datetime(2019,11,7,22,0,0),  datetime.datetime(2019,12,17,15,0,0)],
                                ['Channel:', datetime.datetime(2019,12,19,16,0,0), datetime.datetime(2020,1,13,14,15,0)],
                                ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]

chHistory['PST_Flow'] =  [['Channel:PST Collar Flow', datetime.datetime(2019,4,4,20,51,0), datetime.datetime(2019,4,12,8,20,0)],
                                ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                ['Channel:', datetime.datetime(2019,6,5,14,0,0),  datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31),datetime.datetime(2019,10,12,17,29,22)],
                                ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                ['Channel:', datetime.datetime(2019,11,7,22,0,0),  datetime.datetime(2019,12,17,15,0,0)],
                                ['Channel:', datetime.datetime(2019,12,19,16,0,0), datetime.datetime(2020,1,13,14,15,0)],
                                ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]

chHistory['P_Bottom_Temp_Questionable'] =  [['Channel:LBNL 08', datetime.datetime(2019,1,1), datetime.datetime(2019,4,3,18,0,0)],
                                ['Channel:', datetime.datetime(2019,4,4,21,0,0), datetime.datetime(2019,4,12,8,20,0)],
                                ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                ['Channel:', datetime.datetime(2019,6,5,14,0,0),  datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31),datetime.datetime(2019,10,12,17,29,22)],
                                ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)]]

chHistory['P_Bottom_Temp_Upgraded'] =  [['Channel:LBNL 08', datetime.datetime(2019,12,19,15,30,0),  datetime.datetime(2020,1,14,0,45,0)],
                                ['Channel:LBNL 04', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]

chHistory['P_Interval_Temp_Questionable'] =  [['Channel:LBNL 04', datetime.datetime(2019,1,1), datetime.datetime(2019,4,3,18,0,0)],
                                ['Channel:', datetime.datetime(2019,4,4,21,0,0), datetime.datetime(2019,4,12,8,20,0)],
                                ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                ['Channel:', datetime.datetime(2019,6,5,14,0,0),  datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31),datetime.datetime(2019,10,12,17,29,22)],
                                ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)]]

chHistory['P_Interval_Temp_Upgraded'] =  [['Channel:PNNL 05', datetime.datetime(2019,11,7,22,0,0), datetime.datetime(2019,12,17,15,0,0)],
                                ['Channel:LBNL 04', datetime.datetime(2019,12,19,15,30,0),  datetime.datetime(2020,1,14,0,45,0)],
                                ['Channel:LBNL 08', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]

chHistory['InjectionIntervalTemp'] = [['Channel:LBNL 02', datetime.datetime(2019,1,1), datetime.datetime(2019,4,3,18,0,0)],
                                   ['Channel:', datetime.datetime(2019,4,4,21,0,0), datetime.datetime(2019,4,12,8,20,0)],
                                   ['Channel:', datetime.datetime(2019,4,17,15,20,0), datetime.datetime(2019,6,4,14,0,0)],
                                   ['Channel:', datetime.datetime(2019,6,5,14,0,0),  datetime.datetime(2019,8,16,23,34,59)],
                                  ['Channel:', datetime.datetime(2019,8,17,21,16,31),datetime.datetime(2019,10,12,17,29,22)],
                                   ['Channel:', datetime.datetime(2019,10,14,16,39,56), datetime.datetime(2019,10,29,21,0,0)],
                                   ['Channel:', datetime.datetime(2019,10,30,20,0,0), datetime.datetime(2019,11,1,12)],
                                   ['Channel:', datetime.datetime(2019,11,7,22,0,0), datetime.datetime(2020,1,14,0,45,0)],
                                   ['Channel:', datetime.datetime(2020,1,15,17,30,0), datetime.datetime(2020,2,3)]]



for ch in chHistory:
    outFile = open( ch + '.csv', 'w')
    if not ch in chLim:
        chLim[ch] = [-1e6, 1e6]
    for c in chHistory[ch]:
        if c[0][0:7] == 'Channel':
            if len(c[0]) > 8:  # otherwise, channel name is not given, meaning this is just a break, not a channel switch
                chName = c[0][8:]
            ifile0 = bisect.bisect_right(time1File, c[1])
            ifile1 = bisect.bisect_left(time1File, c[2]) + 1

            for iFile in range(ifile0, ifile1):
                ich = MapChannelInFile ('RawFlowData/'+csvFiles[iFile], chName)
                if i < 0:
                    print ('Channel name error.  Exiting')
                else:
                    myTime0 = np.genfromtxt('RawFlowData/'+csvFiles[iFile], dtype=str, usecols=0, skip_header = 3, delimiter=',')
                    myData0 = np.genfromtxt('RawFlowData/'+csvFiles[iFile], dtype=None, usecols=ich, skip_header = 3, delimiter=',')
                    
                    myTime = []
                    myData = []
                    for j in range(len(myTime0)):
                        if myData0[j] > chLim[ch][0] and myData0[j] < chLim[ch][1]:
                            myTime.append(myTime0[j])
                            myData.append(myData0[j])
                        
                    
                    j0 = 0
                    j1 = len(myTime)
                    
                    if iFile == ifile0:
                        realTime = []
                        for t in myTime:
                            realTime.append(datetime.datetime.strptime(t, '%m/%d/%y %H:%M:%S'))
                        j0 = bisect.bisect_left(realTime, c[1])
                    if iFile == ifile1 - 1:           
                        realTime = []
                        for t in myTime:
                            realTime.append(datetime.datetime.strptime(t, '%m/%d/%y %H:%M:%S'))
                        j1 = bisect.bisect(realTime, c[2])
     
                    for i in range(j0, j1):
                        outFile.write(myTime[i]+ ', ' + str(myData[i]) )
                        if i == j0:
                            outFile.write(', Start File "' + csvFiles[iFile] + '", channel name: ' +chName )
                        if  i == j1 - 1:
                            outFile.write(', End of File "' + csvFiles[iFile] + '", channel name: ' +chName )
                            
                        if myTime[i] in CSVNotes:
                            outFile.write(', ' + CSVNotes[myTime[i]])
                            #print (myTime[i], CSVNotes[myTime[i]])
                        
                        outFile.write('\n')
            
    outFile.close()                    
                        
                    
