import matplotlib.pyplot as plt
import matplotlib
import datetime as datetime

from datetime import timedelta
import numpy as np
import pickle
import bisect
from matplotlib.backends.backend_pdf import PdfPages


def ResampleData(T,V):
    # We first identify gaps between data to avoid average data belonging to different segments
    tGap = []
    for i in range(len(T)-1):
        tGap.append( abs((T[i+1] - T[i]).total_seconds() ))
    
    sortedIDs = [x for _,x in sorted(zip(tGap, range(len(T)-1)))]
    tGap.sort()
    #sortedIDs.reverse()
    
    n = bisect.bisect(tGap, 60)
    
    sortedIDs = sortedIDs[n:]
    sortedIDs.append(len(T)-1)
    
    sortedIDs.sort()
    
    sortedIDs.insert(0,-1)
    
    # sortedIDs are the IDs of the end of the segments
    
    t = []
    v = []
    
    for i in  range(len(sortedIDs)-1):
        
        m0 = sortedIDs[i] + 1
        m1 = sortedIDs[i + 1]
        
        
        t.append ([])
        v.append ([])
        t[-1].append(T[m0])
        v[-1].append(V[m0])

        t0 = T[m0]
        i0 = m0
        for j in range(m0+1, m1+1):
            if (T[j]-t0).total_seconds() >= 3600:
                t[-1].append(T[i0] + timedelta(seconds=1800))
                v[-1].append(np.average(V[i0:j]))
                i0 = j
                t0 = T[j]

        t[-1].append(T[m1])
        v[-1].append(V[m1])

    return (t, v)


str2date = lambda x: datetime.datetime.strptime(x.decode("utf-8"), '%m/%d/%y %H:%M:%S')


# When you run it the first time, change the if False to if True to read all csv and generate a pickle file to save time in subsequent runs.
roots = ['InjectionPressure', 'InjectionRate','P_Interval_Flow','P_Bottom_Flow', 'PDT_Flow', 'PST_Flow', 'InjectionIntervalTemp','P_Bottom_Temp_Questionable','P_Bottom_Temp_Upgraded','P_Interval_Temp_Questionable','P_Interval_Temp_Upgraded']
if False:
    AllData = {}
    for root in roots:
        print (root)
        myTime = np.genfromtxt(root+'.csv', dtype=None, usecols=0, delimiter=',', converters = {0: str2date}, skip_header=0)
        myV = np.genfromtxt(root+'.csv', dtype=None, usecols=1, delimiter=',')
        AllData[root] = [myTime, myV]
    pickleFile = open('AllData.pickle', "wb")
    pickle.dump(AllData, pickleFile)
    pickleFile.close()
    exit()
else:
    pickleFile = open('AllData.pickle', "rb")
    AllData= pickle.load(pickleFile)
    pickleFile.close()
    print ('Finished Loading')




for root in AllData:
    outFile = open(root+'_hourly.csv', 'w')
    t, v = ResampleData(AllData[root][0], AllData[root][1])
    outFile.write ('Time, ' + root + '\n')
    
    for i in range(len(t)):
        for j in range(len(t[i])):
            outFile.write(str(t[i][j]) + ', ' + str(v[i][j]) + '\n')
